<?php

namespace Controllers;

use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;
use Services\FileService;

class FileController
{
    public function __construct(FileService $service)
    {
        $this->service = $service;
    }

    public function downloadFile(Row $dataset, Response $response)
    {
        $row = $dataset->getRow();
        try {
            $filePath = $this->service->getFileServerUrl();
            $file = $filePath . $row['PATH'];
            $fileName = $row['FILENAME'];

            $this->service->downloadFile($file, $fileName);
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
