create or replace
PROCEDURE GERA_PROD_ACABADO(
    P_CDFILCENT  IN FILIAL.CDFILIAL%TYPE,
    P_CDSERVFILI IN SERVICO.CDSERVFILI%TYPE,
    P_DTRETIRADA IN RETIRADA.DTRETIRADA%TYPE,
    P_NRCONSPLAN IN CONSPLAN.NRCONSPLAN%TYPE
)
IS
  V_CDFILIAL        VARCHAR2(4);
  V_NRLANCAMENTO    VARCHAR2(20);
  V_IDSTATUSPRODACA VARCHAR2(1);
  V_QUANTIDADE      FLOAT;
  V_DTRETIRADALANC  RETIRADA.DTRETIRADA%TYPE;
  V_CDSERVFILI      SERVICO.CDSERVFILI%TYPE;
  V_NRLANCPRODACA   GERAPRODACABADO.NRLANCPRODACA%TYPE;
  V_NRCARDAPIO      CARDADIA.NRCARDAPIO%TYPE;
  V_NRRETIRADA      RETIRADA.DTRETIRADA%TYPE;

  V_QTDETOTAL       PRODACABAPRATO.QTPRODACABADO%TYPE;
  V_VRTOTAL         RECPRATPRODACAB.VRTOTARECEPRAT%TYPE;
  
  V_CDPROD          PRODACABAPRATO.CDPRODACABADO%TYPE;  
  V_CDPRODACABADO   PRODACABAPRATO.CDPRODACABADO%TYPE;
  V_QTPRODACABADO   PRODACABAPRATO.QTPRODACABADO%TYPE;

BEGIN

/*Exclui Gerao de Produtos existente para essa data que no esteja com o status concludo.*/

  DELETE FROM RECPRATPRODACAB R
   WHERE CDFILIAL = P_CDFILCENT
     AND DTRETIRADALANC = P_DTRETIRADA
     AND NOT EXISTS (SELECT CDPRODACABADO
                       FROM PRODACABAPRATO
                      WHERE R.CDFILIAL = CDFILIAL
                        AND R.DTRETIRADALANC = DTRETIRADALANC
                        AND R.CDPRODACABADO = CDPRODACABADO
                        AND IDSTATUSPRODACA = 'C');

  DELETE FROM CONSFILIAGREGA C
   WHERE CDFILIAL = P_CDFILCENT
     AND DTRETIRADALANC = P_DTRETIRADA
     AND NOT EXISTS (SELECT CDPRODACABADO
                       FROM PRODACABAPRATO
                      WHERE C.CDFILIAL = CDFILIAL
                        AND C.DTRETIRADALANC = DTRETIRADALANC
                        AND C.CDPRODACABADO = CDPRODACABADO
                        AND IDSTATUSPRODACA = 'C');

  DELETE FROM DISTRIREFEICAO D
   WHERE CDFILIAL = P_CDFILCENT
     AND DTRETIRADALANC = P_DTRETIRADA
     AND NOT EXISTS (SELECT CDPRODACABADO
                       FROM PRODACABAPRATO
                      WHERE D.CDFILIAL = CDFILIAL
                        AND D.DTRETIRADALANC = DTRETIRADALANC
                        AND D.CDPRODACABADO = CDPRODACABADO
                        AND IDSTATUSPRODACA = 'C');   

  DELETE FROM PRODACABAPRATO P
   WHERE CDFILIAL = P_CDFILCENT
     AND DTRETIRADALANC = P_DTRETIRADA
     AND NOT EXISTS (SELECT CDPRODACABADO
                       FROM PRODACABAPRATO
                      WHERE P.CDFILIAL = P.CDFILIAL
                        AND P.DTRETIRADALANC = DTRETIRADALANC
                        AND P.CDPRODACABADO = CDPRODACABADO
                        AND IDSTATUSPRODACA = 'C');

  SELECT COUNT(*)
    INTO V_QUANTIDADE
    FROM PRODACABAPRATO
   WHERE CDFILIAL = P_CDFILCENT
     AND DTRETIRADALANC = P_DTRETIRADA;

  IF V_QUANTIDADE = 0 THEN
     DELETE FROM GERAPRODACABADO
      WHERE CDFILIAL = P_CDFILCENT
        AND DTRETIRADALANC = P_DTRETIRADA;

  /*Inclui a Gerao de Produto Acabado ---------------------------------------- */

     /* Busca o nmero do lanamento do produto acabado */
     NOVO_CODIGO('GERAPRODACABADO' || P_CDFILCENT, V_NRLANCAMENTO);
     V_NRLANCPRODACA := SUBSTR(V_NRLANCAMENTO, 11, 10);

     INSERT INTO GERAPRODACABADO
        (CDFILIAL, DTRETIRADALANC, CDSERVFILI, NRLANCPRODACA, DTLANCPRODACA)
     VALUES
        (P_CDFILCENT, P_DTRETIRADA, P_CDSERVFILI, V_NRLANCPRODACA, SYSDATE());

  END IF;

/*Inclui os Produtos Acabados correspondentes ---------------------------------*/

  FOR PRODACABADO IN (SELECT CP.NRCONSPLAN, CP.CDFAPRATCPLA, CP.CDPRATCONSPL,
                             SUM(NVL(CP.QTCONSPLAN,0)) AS QTCONSPLAN,  P.NMPRATO,
                             PR.NMPRODUTO, PR.SGUNIDADE, PR.CDARVPROD, PR.CDPRODUTO, CP.CDTPPRATCPLA
                        FROM CONSPLAN CP, PRATO P,
                             (SELECT PS.CDFILAUXPRAT, PS.CDPRATO, PS.CDPRODPRODUCAO, PS.CDFILIAL, PS.CDSERVFILI, 'S' AS IDTIPO,
                                     PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                                FROM PRATSERV PS, PRODUTO PO
                                WHERE PS.CDPRODPRODUCAO = PO.CDPRODUTO
                              UNION ALL
                              SELECT PF.CDFILAUXPRAT, PF.CDPRATO, PF.CDPRODPRODUCAO, PF.CDFILIAL, NULL AS CDSERVFILI, 'F' AS IDTIPO,
                                     PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                                FROM PRATFILI PF, PRODUTO PO
                               WHERE PF.CDPRODPRODUCAO = PO.CDPRODUTO
                              UNION ALL
                              SELECT PP.CDFILAUXPRAT, PP.CDPRATO, PP.CDPRODPRODUCAO, NULL AS CDFILIAL, NULL AS CDSERVFILI, 'P' AS IDTIPO,
                                     PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                                FROM PRATPADR PP, PRODUTO PO
                               WHERE PP.CDPRODPRODUCAO = PO.CDPRODUTO) PR
                       WHERE NVL(PR.CDFILIAL, CP.CDFILICPLA) = CP.CDFILICPLA
                         AND NVL(PR.CDSERVFILI, CP.CDSERVCPLA) = CP.CDSERVCPLA
                         AND PR.CDPRATO = CP.CDPRATCONSPL
                         AND PR.CDFILAUXPRAT = CP.CDFAPRATCPLA
                         AND PR.IDTIPO = RECEITA_UTILIZADA(CP.CDPRATCONSPL, CP.CDFAPRATCPLA, CP.CDFILICPLA, CP.CDSERVCPLA)
                         AND P.CDPRATO = CP.CDPRATCONSPL
                         AND P.CDFILAUXPRAT = CP.CDFAPRATCPLA
                         AND CP.NRCONSPLAN = P_NRCONSPLAN
                      GROUP BY CP.NRCONSPLAN, CP.CDFAPRATCPLA, CP.CDPRATCONSPL, P.NMPRATO,
                               PR.NMPRODUTO, PR.SGUNIDADE, PR.CDARVPROD, PR.CDPRODUTO,
                               CP.CDTPPRATCPLA
                      ORDER BY PR.NMPRODUTO, PR.CDARVPROD) LOOP

    BEGIN
       SELECT IDSTATUSPRODACA
         INTO V_IDSTATUSPRODACA
         FROM PRODACABAPRATO
        WHERE CDFILIAL = P_CDFILCENT
          AND DTRETIRADALANC = P_DTRETIRADA
          AND CDPRODACABADO = PRODACABADO.CDPRODUTO
          AND CDTIPOPRAT = PRODACABADO.CDTPPRATCPLA;
    EXCEPTION
       WHEN NO_DATA_FOUND THEN BEGIN
          V_IDSTATUSPRODACA := 'P';
       END;
    END;

    IF V_IDSTATUSPRODACA = 'P' THEN
       INSERT INTO PRODACABAPRATO
       (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, QTPRODACABADO, IDTPPRODACABADO, CDTIPOPRAT)
       VALUES
       (P_CDFILCENT, P_DTRETIRADA, PRODACABADO.CDPRODUTO, 0, 'P', PRODACABADO.CDTPPRATCPLA);
    END IF;

  END LOOP;

/*Inclui o consumo dos produtos por filial/servio -----------------------------*/

  FOR CONSUMOFILIAL IN (SELECT DISTINCT PR.CDPRODUTO, CP.CDFILICPLA, CP.CDSERVCPLA,
                               CP.QTCOMESTCPLA, PR.SGUNIDADE,
                               CP.DTLIMITECPLA, PA.CDFILAUXPRAT, PA.CDPRATO, PR.QTPADRAO, CP.CDTPPRATCPLA
                          FROM CONSPLAN CP, PRATO PA,
                               (SELECT PS.CDFILAUXPRAT, PS.CDPRATO, PS.CDPRODPRODUCAO, PS.CDFILIAL, PS.CDSERVFILI, 'S' AS IDTIPO,
                                       PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO, MAX(NVL(PS.QTPADRAOSERV, 0)) AS QTPADRAO
                                   FROM PRATSERV PS, PRODUTO PO
                                  WHERE PS.CDPRODPRODUCAO = PO.CDPRODUTO
                                GROUP BY PS.CDFILAUXPRAT, PS.CDPRATO, PS.CDPRODPRODUCAO, PS.CDFILIAL, PS.CDSERVFILI, 'S',
                                         PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                                UNION ALL
                                SELECT PF.CDFILAUXPRAT, PF.CDPRATO, PF.CDPRODPRODUCAO, PF.CDFILIAL, NULL AS CDSERVFILI, 'F' AS IDTIPO,
                                       PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO, MAX(NVL(PF.QTPADRAOFILI, 0)) AS QTPADRAO
                                  FROM PRATFILI PF, PRODUTO PO
                                 WHERE PF.CDPRODPRODUCAO = PO.CDPRODUTO
                                GROUP BY PF.CDFILAUXPRAT, PF.CDPRATO, PF.CDPRODPRODUCAO, PF.CDFILIAL, NULL, 'F',
                                         PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO
                                UNION ALL
                                SELECT PP.CDFILAUXPRAT, PP.CDPRATO, PP.CDPRODPRODUCAO, NULL AS CDFILIAL, NULL AS CDSERVFILI, 'P' AS IDTIPO,
                                       PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO, MAX(NVL(PP.QTPADRAOPRAT, 0)) AS QTPADRAO
                                  FROM PRATPADR PP, PRODUTO PO
                                 WHERE PP.CDPRODPRODUCAO = PO.CDPRODUTO
                                GROUP BY PP.CDFILAUXPRAT, PP.CDPRATO, PP.CDPRODPRODUCAO, NULL, NULL, 'P',
                                         PO.NMPRODUTO, PO.SGUNIDADE, PO.CDARVPROD, PO.CDPRODUTO) PR
                         WHERE NVL(PR.CDFILIAL, CP.CDFILICPLA) = CP.CDFILICPLA
                           AND NVL(PR.CDSERVFILI, CP.CDSERVCPLA) = CP.CDSERVCPLA
                           AND PR.CDPRATO = CP.CDPRATCONSPL
                           AND PR.CDFILAUXPRAT = CP.CDFAPRATCPLA
                           AND PR.IDTIPO = RECEITA_UTILIZADA(CP.CDPRATCONSPL, CP.CDFAPRATCPLA, CP.CDFILICPLA, CP.CDSERVCPLA)
                           AND CP.CDFAPRATCPLA = PA.CDFILAUXPRAT
                           AND CP.CDPRATCONSPL = PA.CDPRATO
                           AND CP.NRCONSPLAN = P_NRCONSPLAN) LOOP

    BEGIN
       SELECT IDSTATUSPRODACA
         INTO V_IDSTATUSPRODACA
         FROM PRODACABAPRATO
        WHERE CDFILIAL = P_CDFILCENT
          AND DTRETIRADALANC = P_DTRETIRADA
          AND CDPRODACABADO = CONSUMOFILIAL.CDPRODUTO
          AND CDTIPOPRAT = CONSUMOFILIAL.CDTPPRATCPLA;
    EXCEPTION
       WHEN NO_DATA_FOUND THEN BEGIN
          V_IDSTATUSPRODACA := 'P';
       END;
    END;

    IF V_IDSTATUSPRODACA = 'P' THEN
       INSERT INTO CONSFILIAGREGA
       (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, CDFILAGREGSERV,
        CDSERVFILAGREGA, QTPRODSERVCONS, DTENTRPRODSERV, QTCOMESERVCONS, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT)
       VALUES
       (P_CDFILCENT, P_DTRETIRADA, CONSUMOFILIAL.CDPRODUTO, CONSUMOFILIAL.CDFILICPLA,
        CONSUMOFILIAL.CDSERVCPLA, CONSUMOFILIAL.QTPADRAO*CONSUMOFILIAL.QTCOMESTCPLA, CONSUMOFILIAL.DTLIMITECPLA,
        CONSUMOFILIAL.QTCOMESTCPLA, CONSUMOFILIAL.CDTPPRATCPLA, CONSUMOFILIAL.CDPRATO, CONSUMOFILIAL.CDFILAUXPRAT);

       BEGIN
        SELECT CDPRODUTO
          INTO V_CDPROD
         FROM PRODFILI
        WHERE CDFILIAL = CONSUMOFILIAL.CDFILICPLA
          AND CDPRODUTO = CONSUMOFILIAL.CDPRODUTO;
       EXCEPTION
          WHEN NO_DATA_FOUND THEN BEGIN
             INSERT INTO PRODFILI (CDFILIAL, CDPRODUTO, IDCNTRESTOQ, IDPRODATIV)
                           VALUES (CONSUMOFILIAL.CDFILICPLA, CONSUMOFILIAL.CDPRODUTO, 'S', 'A');
          END;
       END;


    END IF;
  END LOOP;

/*Inclui os produtos utilizados na receita -------------------------------------*/

  FOR PRODRECEITA IN (SELECT RC.CDPRATO,
                             RC.CDFILAUXPRAT,
                             RC.CDPRODUTO,
                             ROUND(NVL(CUSTO_PRODUTO(P_CDFILCENT, RC.CDPRODUTO, DECODE(PF.CDTIPCUSTEST, '', '03', PF.CDTIPCUSTEST), CP.DTCONSPLAN, SYSDATE), 0),5) AS CUSTOPROD,
                             RC.CDFILICPLA,
                             RC.CDSERVCPLA,
                             RC.TIPO,
                             RC.QTPRODUTO AS QUANTIDADE,
                             RC.QTCOMESTCPLA,
                             RC.QTPRODUTO * RC.QTCOMESTCPLA * ROUND(NVL(CUSTO_PRODUTO(P_CDFILCENT, RC.CDPRODUTO, DECODE(PF.CDTIPCUSTEST, '', '03', PF.CDTIPCUSTEST), CP.DTCONSPLAN, SYSDATE), 0),5) AS VALORTOTAL,
                             RC.QTPRODUTO * RC.QTCOMESTCPLA AS QTDETOTAL,
                             RC.CDPRODPRODUCAO,
                             NVL(RC.IDTPREQPROD, 'P') AS IDTPREQPROD,
                             NVL(RC.QTCOMPLPROD, 0) AS QTCOMPLPROD,
                             NVL(RC.IDUTCOMPENTDIR, 'N') AS IDUTCOMPENTDIR,
                             CP.DTLIMITECPLA,
                             RC.CDTPPRATCPLA
                        FROM PRODUTO PD, PARAMFILIAL PF, CONSPLAN CP, PRODUTO PP,
                             (SELECT R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODRECSER AS QTPRODUTO,
                                     R.SGUNIDADE, 'S' AS TIPO, CP.CDFILICPLA, CP.CDSERVCPLA,
                                     SUM(CP.QTCOMESTCPLA) AS QTCOMESTCPLA, CP.NRCONSPLAN, R.IDTPREQPRODSERV AS IDTPREQPROD,
                                     R.QTCOMPLPRODSERV AS QTCOMPLPROD, R.IDUTCOMPENTDIRS AS IDUTCOMPENTDIR, PS.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                                FROM RECESERV R, COMPCARD C, CARDADIA D, CONSPLAN CP, PRATSERV PS
                               WHERE (D.CDFILIAL     = CP.CDFILICPLA)
                                 AND (D.CDSERVFILI   = CP.CDSERVCPLA)
                                 AND (D.DTCARDAPIO   = CP.DTCONSPLAN)
                                 AND (C.CDFILIAL     = D.CDFILIAL)
                                 AND (C.NRCARDAPIO   = D.NRCARDAPIO)
                                 AND (R.CDFILIAL     = CP.CDFILICPLA)
                                 AND (R.CDSERVFILI   = CP.CDSERVCPLA)
                                 AND (R.CDFILAUXPRAT = C.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = C.CDPRATO)
                                 AND (R.CDFILAUXPRAT = CP.CDFAPRATCPLA)
                                 AND (R.CDPRATO      = CP.CDPRATCONSPL)
                                 AND (R.CDFILAUXPRAT = PS.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = PS.CDPRATO)
                                 AND (R.CDFILIAL     = PS.CDFILIAL)
                                 AND (R.CDSERVFILI   = PS.CDSERVFILI)
                                 AND (CP.CDPRODCPLA  = R.CDPRODUTO)
                                 AND (CP.NRCONSPLAN = P_NRCONSPLAN)
                              GROUP BY R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODRECSER,
                                       R.SGUNIDADE, CP.CDFILICPLA, CP.CDSERVCPLA, CP.NRCONSPLAN,
                                       R.IDTPREQPRODSERV, R.QTCOMPLPRODSERV, R.IDUTCOMPENTDIRS, PS.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                              UNION ALL
                              SELECT R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODRECLOC AS QTPRODUTO,
                                     R.SGUNIDADE, 'F' AS TIPO, CP.CDFILICPLA, CP.CDSERVCPLA,
                                     SUM(CP.QTCOMESTCPLA) AS QTCOMESTCPLA, CP.NRCONSPLAN, R.IDTPREQPRODFILI AS IDTPREQPROD,
                                     R.QTCOMPLPRODFILI AS QTCOMPLPROD, R.IDUTCOMPENTDIRF AS IDUTCOMPENTDIR, PF.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                                FROM RECEFILI R, COMPCARD C, CARDADIA D, CONSPLAN CP, PRATFILI PF
                               WHERE (D.CDFILIAL     = CP.CDFILICPLA)
                                 AND (D.CDSERVFILI   = CP.CDSERVCPLA)
                                 AND (D.DTCARDAPIO   = CP.DTCONSPLAN)
                                 AND (C.CDFILIAL     = D.CDFILIAL)
                                 AND (C.NRCARDAPIO   = D.NRCARDAPIO)
                                 AND (R.CDFILIAL     = CP.CDFILICPLA)
                                 AND (R.CDFILAUXPRAT = C.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = C.CDPRATO)
                                 AND (R.CDFILAUXPRAT = CP.CDFAPRATCPLA)
                                 AND (R.CDPRATO      = CP.CDPRATCONSPL)
                                 AND (R.CDFILAUXPRAT = PF.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = PF.CDPRATO)
                                 AND (R.CDFILIAL     = PF.CDFILIAL)
                                 AND (CP.CDPRODCPLA  = R.CDPRODUTO)
                                 AND (CP.NRCONSPLAN = P_NRCONSPLAN)
                                 AND NOT EXISTS (SELECT CDPRATO
                                                   FROM RECESERV
                                                  WHERE (CDFILAUXPRAT = R.CDFILAUXPRAT)
                                                    AND (CDPRATO      = R.CDPRATO)
                                                    AND (CDFILIAL     = CP.CDFILICPLA)
                                                    AND (CDSERVFILI   = CP.CDSERVCPLA))
                              GROUP BY R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODRECLOC,
                                       R.SGUNIDADE, CP.CDFILICPLA, CP.CDSERVCPLA, CP.NRCONSPLAN,
                                       R.IDTPREQPRODFILI, R.QTCOMPLPRODFILI, R.IDUTCOMPENTDIRF, PF.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                              UNION ALL
                              SELECT R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODPRAT AS QTPRODUTO,
                                     R.SGUNIDADE, 'P' AS TIPO, CP.CDFILICPLA, CP.CDSERVCPLA,
                                     SUM(CP.QTCOMESTCPLA) AS QTCOMESTCPLA, CP.NRCONSPLAN, R.IDTPREQPRODPADR AS IDTPREQPROD,
                                     R.QTCOMPLPRODPADR AS QTCOMPLPROD, R.IDUTCOMPENTDIRP AS IDUTCOMPENTDIR, PP.CDPRODPRODUCAO, CP.CDTPPRATCPLA
                                FROM RECEPADR R, COMPCARD C, CARDADIA D, CONSPLAN CP, PRATPADR PP
                               WHERE (D.CDFILIAL     = CP.CDFILICPLA)
                                 AND (D.CDSERVFILI   = CP.CDSERVCPLA)
                                 AND (D.DTCARDAPIO   = CP.DTCONSPLAN)
                                 AND (C.CDFILIAL     = D.CDFILIAL)
                                 AND (C.NRCARDAPIO   = D.NRCARDAPIO)
                                 AND (R.CDFILAUXPRAT = C.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = C.CDPRATO)
                                 AND (R.CDFILAUXPRAT = CP.CDFAPRATCPLA)
                                 AND (R.CDPRATO      = CP.CDPRATCONSPL)
                                 AND (R.CDFILAUXPRAT = PP.CDFILAUXPRAT)
                                 AND (R.CDPRATO      = PP.CDPRATO)
                                 AND (CP.CDPRODCPLA  = R.CDPRODUTO)
                                 AND (CP.NRCONSPLAN  = P_NRCONSPLAN)
                                 AND NOT EXISTS (SELECT CDPRATO
                                                   FROM RECEFILI
                                                  WHERE (CDFILAUXPRAT = R.CDFILAUXPRAT)
                                                    AND (CDPRATO      = R.CDPRATO)
                                                    AND (CDFILIAL     = CP.CDFILICPLA))
                                 AND NOT EXISTS (SELECT CDPRATO
                                                   FROM RECESERV
                                                  WHERE (CDFILAUXPRAT = R.CDFILAUXPRAT)
                                                    AND (CDPRATO      = R.CDPRATO)
                                                    AND (CDFILIAL     = CP.CDFILICPLA)
                                                    AND (CDSERVFILI   = CP.CDSERVCPLA))
                              GROUP BY R.CDPRATO, R.CDFILAUXPRAT, R.CDPRODUTO, R.QTPRODPRAT,
                                       R.SGUNIDADE, CP.CDFILICPLA, CP.CDSERVCPLA, CP.NRCONSPLAN,
                                       R.IDTPREQPRODPADR, R.QTCOMPLPRODPADR, R.IDUTCOMPENTDIRP, PP.CDPRODPRODUCAO, CP.CDTPPRATCPLA) RC
                        WHERE (RC.CDPRODUTO    = PD.CDPRODUTO)
                          AND (PF.CDFILIAL     = P_CDFILCENT)
                          AND (CP.NRCONSPLAN   = RC.NRCONSPLAN)
                          AND (RC.CDPRODUTO    = CP.CDPRODCPLA)
                          AND (RC.CDTPPRATCPLA = CP.CDTPPRATCPLA)
                          AND (PP.CDPRODUTO    = RC.CDPRODPRODUCAO)
                       GROUP BY RC.CDPRATO, RC.CDFILAUXPRAT, RC.CDPRODUTO, PF.CDTIPCUSTEST,
                               CP.DTCONSPLAN, RC.CDFILICPLA, RC.CDSERVCPLA, RC.TIPO, RC.QTPRODUTO,
                               RC.QTCOMESTCPLA, RC.CDPRODPRODUCAO, NVL(RC.IDTPREQPROD, 'P'), NVL(RC.QTCOMPLPROD, 0),
                               NVL(RC.IDUTCOMPENTDIR, 'N'), CP.DTLIMITECPLA, CP.CDTPPRATCPLA, RC.CDTPPRATCPLA) LOOP

    IF (PRODRECEITA.IDTPREQPROD = 'P') THEN

       BEGIN
          SELECT IDSTATUSPRODACA
            INTO V_IDSTATUSPRODACA
            FROM PRODACABAPRATO
           WHERE CDFILIAL = P_CDFILCENT
             AND DTRETIRADALANC = P_DTRETIRADA
             AND CDPRODACABADO = PRODRECEITA.CDPRODPRODUCAO
             AND CDTIPOPRAT = PRODRECEITA.CDTPPRATCPLA;
       EXCEPTION
          WHEN NO_DATA_FOUND THEN BEGIN
             V_IDSTATUSPRODACA := 'P';
          END;
       END;
       
       IF V_IDSTATUSPRODACA = 'P' THEN
          IF (PRODRECEITA.IDUTCOMPENTDIR = 'N') THEN
             INSERT INTO RECPRATPRODACAB
             (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, CDFILAGREGSERV, CDSERVFILAGREGA, IDRECEITAPRACA,
              CDPRODUTO, QTPRODRECEPRAT, VRUNITRECEPRAT, VRTOTARECEPRAT, QTTOTARECEPRAT, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT)
             VALUES
             (P_CDFILCENT, P_DTRETIRADA, PRODRECEITA.CDPRODPRODUCAO, PRODRECEITA.CDFILICPLA, PRODRECEITA.CDSERVCPLA, PRODRECEITA.TIPO,
              PRODRECEITA.CDPRODUTO, PRODRECEITA.QUANTIDADE + PRODRECEITA.QTCOMPLPROD, PRODRECEITA.CUSTOPROD, PRODRECEITA.VALORTOTAL, PRODRECEITA.QTDETOTAL, PRODRECEITA.CDTPPRATCPLA, PRODRECEITA.CDPRATO, PRODRECEITA.CDFILAUXPRAT);
          ELSE
             INSERT INTO RECPRATPRODACAB
             (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, CDFILAGREGSERV, CDSERVFILAGREGA, IDRECEITAPRACA,
              CDPRODUTO, QTPRODRECEPRAT, VRUNITRECEPRAT, VRTOTARECEPRAT, QTTOTARECEPRAT, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT)
             VALUES
             (P_CDFILCENT, P_DTRETIRADA, PRODRECEITA.CDPRODPRODUCAO, PRODRECEITA.CDFILICPLA, PRODRECEITA.CDSERVCPLA, PRODRECEITA.TIPO,
              PRODRECEITA.CDPRODUTO, PRODRECEITA.QUANTIDADE, PRODRECEITA.CUSTOPROD, PRODRECEITA.VALORTOTAL, PRODRECEITA.QTDETOTAL, PRODRECEITA.CDTPPRATCPLA, PRODRECEITA.CDPRATO, PRODRECEITA.CDFILAUXPRAT);
          END IF;
       END IF;
    END IF;

    IF (PRODRECEITA.IDTPREQPROD = 'D') THEN

       BEGIN
          SELECT IDSTATUSPRODACA
            INTO V_IDSTATUSPRODACA
            FROM PRODACABAPRATO
           WHERE CDFILIAL = P_CDFILCENT
             AND DTRETIRADALANC = P_DTRETIRADA
             AND CDPRODACABADO = PRODRECEITA.CDPRODUTO
             AND CDTIPOPRAT = PRODRECEITA.CDTPPRATCPLA;
       EXCEPTION
          WHEN NO_DATA_FOUND THEN BEGIN
             V_IDSTATUSPRODACA := 'P';
          END;
       END;

       IF V_IDSTATUSPRODACA = 'P' THEN

          SELECT MAX(CDPRODACABADO), MAX(QTPRODACABADO)
          INTO V_CDPRODACABADO, V_QTPRODACABADO
          FROM PRODACABAPRATO PP
          WHERE PP.CDFILIAL = P_CDFILCENT
          AND PP.DTRETIRADALANC = P_DTRETIRADA
          AND PP.CDPRODACABADO = PRODRECEITA.CDPRODUTO
          AND PP.CDTIPOPRAT = PRODRECEITA.CDTPPRATCPLA;

          IF (V_CDPRODACABADO IS NULL) THEN
             INSERT INTO PRODACABAPRATO
             (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, QTPRODACABADO, IDTPPRODACABADO, CDTIPOPRAT)
             VALUES
             (P_CDFILCENT, P_DTRETIRADA, PRODRECEITA.CDPRODUTO, PRODRECEITA.QUANTIDADE + PRODRECEITA.QTCOMPLPROD, 'D', PRODRECEITA.CDTPPRATCPLA);
          ELSE
             UPDATE PRODACABAPRATO
             SET QTPRODACABADO = V_QTPRODACABADO + PRODRECEITA.QUANTIDADE + PRODRECEITA.QTCOMPLPROD
             WHERE CDFILIAL = P_CDFILCENT
               AND DTRETIRADALANC = P_DTRETIRADA
               AND CDPRODACABADO = PRODRECEITA.CDPRODUTO
               AND CDTIPOPRAT = PRODRECEITA.CDTPPRATCPLA;
          END IF;

          INSERT INTO CONSFILIAGREGA
          (CDFILIAL, DTRETIRADALANC, CDPRODACABADO, CDFILAGREGSERV,
           CDSERVFILAGREGA, QTPRODSERVCONS, DTENTRPRODSERV, QTCOMESERVCONS,
           VRTOTAPRODSERV, VRUNITPRODSERV, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT)
          VALUES
          (P_CDFILCENT, P_DTRETIRADA, PRODRECEITA.CDPRODUTO, PRODRECEITA.CDFILICPLA,
           PRODRECEITA.CDSERVCPLA, PRODRECEITA.QUANTIDADE*PRODRECEITA.QTCOMESTCPLA, PRODRECEITA.DTLIMITECPLA,
           PRODRECEITA.QTCOMESTCPLA, PRODRECEITA.VALORTOTAL, PRODRECEITA.VALORTOTAL/(PRODRECEITA.QUANTIDADE*PRODRECEITA.QTCOMESTCPLA), PRODRECEITA.CDTPPRATCPLA, PRODRECEITA.CDPRATO, PRODRECEITA.CDFILAUXPRAT);
       END IF;
    END IF;

  END LOOP;

/*Atualiza custo total das filiais agregadas ----------------------------------*/

  FOR CONSFILI IN (SELECT CDPRODACABADO, CDFILAGREGSERV, CDSERVFILAGREGA, CDTIPOPRAT, CDPRATO, CDFILAUXPRAT
                   FROM CONSFILIAGREGA
                   WHERE CDFILIAL = P_CDFILCENT
                     AND DTRETIRADALANC = P_DTRETIRADA) LOOP

    SELECT SUM(VRTOTARECEPRAT)
    INTO V_VRTOTAL
    FROM RECPRATPRODACAB
    WHERE CDFILIAL = P_CDFILCENT
      AND DTRETIRADALANC = P_DTRETIRADA
      AND CDPRODACABADO = CONSFILI.CDPRODACABADO
      AND CDFILAGREGSERV = CONSFILI.CDFILAGREGSERV
      AND CDSERVFILAGREGA = CONSFILI.CDSERVFILAGREGA
      AND CDTIPOPRAT = CONSFILI.CDTIPOPRAT
      AND CDPRATO = CONSFILI.CDPRATO
      AND CDFILAUXPRAT = CONSFILI.CDFILAUXPRAT;

    IF (V_VRTOTAL IS NOT NULL) THEN
      UPDATE CONSFILIAGREGA
      SET VRTOTAPRODSERV = V_VRTOTAL,
          VRUNITPRODSERV = V_VRTOTAL/DECODE(QTPRODSERVCONS,0,1,QTPRODSERVCONS)
      WHERE CDFILIAL = P_CDFILCENT
        AND DTRETIRADALANC = P_DTRETIRADA
        AND CDPRODACABADO = CONSFILI.CDPRODACABADO
        AND CDFILAGREGSERV = CONSFILI.CDFILAGREGSERV
        AND CDSERVFILAGREGA = CONSFILI.CDSERVFILAGREGA
        AND CDTIPOPRAT = CONSFILI.CDTIPOPRAT
        AND CDPRATO = CONSFILI.CDPRATO
        AND CDFILAUXPRAT = CONSFILI.CDFILAUXPRAT;
    END IF;

  END LOOP;

  
/*Atualiza a quantidade de produto acabado total*/
  
  FOR PROACABADO IN (SELECT PP.CDPRODACABADO, PP.CDTIPOPRAT
                     FROM PRODACABAPRATO PP
                     WHERE PP.CDFILIAL = P_CDFILCENT
                     AND PP.DTRETIRADALANC = P_DTRETIRADA) LOOP
    
    SELECT SUM(QTPRODSERVCONS)
    INTO V_QTDETOTAL
    FROM CONSFILIAGREGA
    WHERE CDFILIAL = P_CDFILCENT
    AND DTRETIRADALANC = P_DTRETIRADA
    AND CDPRODACABADO = PROACABADO.CDPRODACABADO
    AND CDTIPOPRAT = PROACABADO.CDTIPOPRAT;

    UPDATE PRODACABAPRATO 
    SET QTPRODACABADO = V_QTDETOTAL
    WHERE CDFILIAL = P_CDFILCENT
    AND DTRETIRADALANC = P_DTRETIRADA
    AND CDPRODACABADO = PROACABADO.CDPRODACABADO
    AND CDTIPOPRAT = PROACABADO.CDTIPOPRAT;     
                     
  END LOOP;

END;
/